## graphviz 14.0.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.21 FATAL_ERROR)
project(Graphviz)

include(FeatureSummary)

# =============================== Build options ================================
set(ENABLE_LTDL AUTO CACHE STRING "Support on-demand plugin loading")
set_property(CACHE ENABLE_LTDL PROPERTY STRINGS AUTO ON OFF)
set(WITH_EXPAT AUTO CACHE STRING "Support HTML-like labels through expat")
set_property(CACHE WITH_EXPAT PROPERTY STRINGS AUTO ON OFF)
option(with_digcola    "DIGCOLA features in neato layout engine" ON )
set(WITH_GVEDIT AUTO CACHE STRING "GVEdit interactive graph editor")
set_property(CACHE WITH_GVEDIT PROPERTY STRINGS AUTO ON OFF)
option(with_ipsepcola  "IPSEPCOLA features in neato layout engine" ON )
option(with_ortho      "ORTHO features in neato layout engine." ON )
option(with_sfdp       "sfdp layout engine." ON )
set(WITH_SMYRNA AUTO CACHE STRING "SMYRNA large graph viewer")
set_property(CACHE WITH_SMYRNA PROPERTY STRINGS AUTO ON OFF)
set(WITH_ZLIB AUTO CACHE STRING "Support raster image compression through zlib")
set_property(CACHE WITH_ZLIB PROPERTY STRINGS AUTO ON OFF)
option(use_coverage    "enables analyzing code coverage" OFF)
option(with_cxx_api    "enables building the C++ API" OFF)
option(with_cxx_tests  "enables building the C++ tests" OFF)
option(use_win_pre_inst_libs
       "enables building using pre-installed Windows libraries" ON)
option(BUILD_SHARED_LIBS "Build in shared lib mode" ON)
set(ENABLE_TCL AUTO CACHE STRING "Build TCL components")
set_property(CACHE ENABLE_TCL PROPERTY STRINGS AUTO ON OFF)
set(ENABLE_SWIG AUTO CACHE STRING "Build language bindings")
set_property(CACHE ENABLE_SWIG PROPERTY STRINGS AUTO ON OFF)
set(ENABLE_SHARP AUTO CACHE STRING "Build C# language bindings")
set_property(CACHE ENABLE_SHARP PROPERTY STRINGS AUTO ON OFF)
set(ENABLE_D AUTO CACHE STRING "Build D language bindings")
set_property(CACHE ENABLE_D PROPERTY STRINGS AUTO ON OFF)
set(ENABLE_GO AUTO CACHE STRING "Build Go language bindings")
set_property(CACHE ENABLE_GO PROPERTY STRINGS AUTO ON OFF)
set(INTGOSIZE AUTO CACHE STRING "Integer size for go, 32 or 64")
set_property(CACHE INTGOSIZE PROPERTY STRINGS AUTO 32 64)
set(ENABLE_GUILE AUTO CACHE STRING "Build Guile language bindings")
set_property(CACHE ENABLE_GUILE PROPERTY STRINGS AUTO ON OFF)
set(ENABLE_JAVA AUTO CACHE STRING "Build Java language bindings")
set_property(CACHE ENABLE_JAVA PROPERTY STRINGS AUTO ON OFF)
set(ENABLE_JAVASCRIPT AUTO CACHE STRING "Build Javascript language bindings")
set_property(CACHE ENABLE_JAVASCRIPT PROPERTY STRINGS AUTO ON OFF)
set(ENABLE_LUA AUTO CACHE STRING "Build Lua language bindings")
set_property(CACHE ENABLE_LUA PROPERTY STRINGS AUTO ON OFF)
set(ENABLE_PERL AUTO CACHE STRING "Build Perl language bindings")
set_property(CACHE ENABLE_PERL PROPERTY STRINGS AUTO ON OFF)
set(ENABLE_PHP AUTO CACHE STRING "Build PHP language bindings")
set_property(CACHE ENABLE_PHP PROPERTY STRINGS AUTO ON OFF)
set(ENABLE_PYTHON AUTO CACHE STRING "Build Python language bindings")
set_property(CACHE ENABLE_PYTHON PROPERTY STRINGS AUTO ON OFF)
set(ENABLE_R AUTO CACHE STRING "Build R language bindings")
set_property(CACHE ENABLE_R PROPERTY STRINGS AUTO ON OFF)
set(ENABLE_RUBY AUTO CACHE STRING "Build Ruby language bindings")
set_property(CACHE ENABLE_RUBY PROPERTY STRINGS AUTO ON OFF)
option(GRAPHVIZ_CLI "Build command line tools" ON)
set(WITH_GDK AUTO CACHE STRING "enable GDK-dependent components (GDK plugin)")
set_property(CACHE WITH_GDK PROPERTY STRINGS AUTO ON OFF)

set(WITH_GHOSTSCRIPT AUTO CACHE STRING
    "enable Ghostscript-dependent components (Ghostscript plugin)")
set_property(CACHE WITH_GHOSTSCRIPT PROPERTY STRINGS AUTO ON OFF)
if(WITH_GHOSTSCRIPT STREQUAL "AUTO")
  set(AUTO_GHOSTSCRIPT ON)
else()
  set(AUTO_GHOSTSCRIPT OFF)
endif()

set(WITH_GTK AUTO CACHE STRING "enable GTK-dependent components (smyrna)")
set_property(CACHE WITH_GTK PROPERTY STRINGS AUTO ON OFF)
if(WITH_GTK STREQUAL "AUTO")
  set(AUTO_GTK ON)
else()
  set(AUTO_GTK OFF)
endif()

set(WITH_POPPLER AUTO CACHE STRING
  "enable Poppler-dependent components (Poppler plugin)")
set_property(CACHE WITH_POPPLER PROPERTY STRINGS AUTO ON OFF)
if(WITH_POPPLER STREQUAL "AUTO")
  set(AUTO_POPPLER ON)
else()
  set(AUTO_POPPLER OFF)
endif()

set(WITH_QUARTZ AUTO CACHE STRING
  "enable Quartz-dependent components (Quartz plugin)")
set_property(CACHE WITH_QUARTZ PROPERTY STRINGS AUTO ON OFF)
if(WITH_QUARTZ STREQUAL "AUTO")
  set(AUTO_QUARTZ ON)
else()
  set(AUTO_QUARTZ OFF)
endif()

set(WITH_RSVG AUTO CACHE STRING
  "enable librsvg-dependent components (Rsvg plugin)")
set_property(CACHE WITH_RSVG PROPERTY STRINGS AUTO ON OFF)
if(WITH_RSVG STREQUAL "AUTO")
  set(AUTO_RSVG ON)
else()
  set(AUTO_RSVG OFF)
endif()

set(WITH_WEBP AUTO CACHE STRING
  "enable WebP-dependent components (WebP plugin)")
set_property(CACHE WITH_WEBP PROPERTY STRINGS AUTO ON OFF)
if(WITH_WEBP STREQUAL "AUTO")
  set(AUTO_WEBP ON)
else()
  set(AUTO_WEBP OFF)
endif()

set(WITH_X AUTO CACHE STRING
  "enable X11-dependent components (xlib plugin, libglcomp, Smyrna)")
set_property(CACHE WITH_X PROPERTY STRINGS AUTO ON OFF)
if(WITH_X STREQUAL "AUTO")
  set(AUTO_X ON)
else()
  set(AUTO_X OFF)
endif()

if(WIN32)
  if(BUILD_SHARED_LIBS)
    # build dynamic-link libraries on Windows, including MinGW
    add_definitions(-DGVDLL)
  endif()

  option(install_win_dependency_dlls "Install 3rd party dependencies" ON)
endif()

if(with_digcola)
  add_definitions(-DDIGCOLA)
endif()

if(with_ipsepcola)
  add_definitions(-DIPSEPCOLA)
endif()

if(with_ortho)
  add_definitions(-DORTHO)
endif()

if(with_sfdp)
  add_definitions(-DSFDP)
endif()

# ===================== Append local CMake module directory ====================
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

# ============================= Build dependencies =============================
find_package(BISON 3.0)
set_package_properties(BISON PROPERTIES TYPE REQUIRED)
find_package(FLEX)
set_package_properties(FLEX PROPERTIES TYPE REQUIRED)
find_program(GZIP gzip)

# ================== Convenient values for CMake configuration =================
if(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
  include(GNUInstallDirs)
  set(BINARY_INSTALL_DIR  "${CMAKE_INSTALL_BINDIR}")
  set(LIBRARY_INSTALL_DIR "${CMAKE_INSTALL_LIBDIR}")
  set(HEADER_INSTALL_DIR  "${CMAKE_INSTALL_INCLUDEDIR}/graphviz")
  set(MAN_INSTALL_DIR     "${CMAKE_INSTALL_MANDIR}")
  set(libdir # cmake-lint: disable=C0103
                          "${CMAKE_INSTALL_FULL_LIBDIR}")
  set(includedir # cmake-lint: disable=C0103
                          "${CMAKE_INSTALL_FULL_INCLUDEDIR}")
  set(DATA_INSTALL_DIR    "${CMAKE_INSTALL_DATAROOTDIR}")
else()
  set(BINARY_INSTALL_DIR  bin)
  set(LIBRARY_INSTALL_DIR lib)
  set(HEADER_INSTALL_DIR  include/graphviz)
  set(MAN_INSTALL_DIR     share/man)
  set(libdir # cmake-lint: disable=C0103
                          "${CMAKE_INSTALL_PREFIX}/${LIBRARY_INSTALL_DIR}")
  set(includedir # cmake-lint: disable=C0103
                          "${CMAKE_INSTALL_PREFIX}/include")
  set(DATA_INSTALL_DIR    share)
endif()

set(PLUGIN_INSTALL_DIR      ${LIBRARY_INSTALL_DIR}/graphviz)
set(PKGCONFIG_DIR           ${LIBRARY_INSTALL_DIR}/pkgconfig)
# TODO: Find a way to check for groff and ps2pdf for manpage pdf generation
# set(MAN_PDF_INSTALL_DIR share/graphviz/doc/pdf)
set(WINDOWS_DEPENDENCY_DIR
    "${CMAKE_CURRENT_SOURCE_DIR}/windows/dependencies/libraries")
set(WINDOWS_DEPENDENCY_VCPKG_DIR "${WINDOWS_DEPENDENCY_DIR}/vcpkg/installed")
if(CMAKE_CL_64)
  set(WINDOWS_DEPENDENCY_DIR "${WINDOWS_DEPENDENCY_DIR}/x64")
  set(WINDOWS_DEPENDENCY_VCPKG_DIR
      "${WINDOWS_DEPENDENCY_VCPKG_DIR}/x64-windows")
else()
  set(WINDOWS_DEPENDENCY_DIR "${WINDOWS_DEPENDENCY_DIR}/x86")
  set(WINDOWS_DEPENDENCY_VCPKG_DIR
      "${WINDOWS_DEPENDENCY_VCPKG_DIR}/x86-windows")
endif()

# see configure.ac GVPLUGIN_CURRENT
set(GVPLUGIN_CURRENT 8)

# see configure.ac GVPLUGIN_REVISION
set(GVPLUGIN_REVISION 2)

# Name of the config file used by Graphviz
set(GVPLUGIN_CONFIG_FILE config${GVPLUGIN_CURRENT})

# ============================ Library dependencies ============================
if(WIN32)
  if(use_win_pre_inst_libs)
    list(APPEND CMAKE_PREFIX_PATH ${WINDOWS_DEPENDENCY_VCPKG_DIR})
    list(APPEND CMAKE_PREFIX_PATH ${WINDOWS_DEPENDENCY_DIR})
    set(PKG_CONFIG_EXECUTABLE
        "${WINDOWS_DEPENDENCY_VCPKG_DIR}/tools/pkgconf/pkgconf.exe"
        CACHE STRING "The pathname of the pkg-config program")
  endif()
  if(MINGW)
    list(APPEND CMAKE_PREFIX_PATH $ENV{MSYSTEM_PREFIX})
  endif()
endif()

find_package(ANN)
find_package(CAIRO)

if(NOT WITH_EXPAT STREQUAL "OFF")
  find_package(EXPAT)
  if(WITH_EXPAT STREQUAL "AUTO")
    if(EXPAT_FOUND)
      message(STATUS "setting -DWITH_EXPAT=ON")
      set(WITH_EXPAT ON)
    else()
      message(STATUS "setting -DWITH_EXPAT=OFF")
      set(WITH_EXPAT OFF)
    endif()
  elseif(NOT EXPAT_FOUND)
    message(FATAL_ERROR "-DWITH_EXPAT=ON and expat not found")
  endif()
endif()

find_package(GTS)

if(NOT WITH_SMYRNA STREQUAL "OFF")
  find_package(Freetype)
  find_package(GLUT)
  if(WITH_GTK)
    find_package(GTK2)
    if(NOT AUTO_GTK)
      set_package_properties(GTK2 PROPERTIES TYPE REQUIRED)
    endif()
  else()
    message(STATUS "skipping GTK discovery because -DWITH_GTK=OFF")
    set(GTK2_FOUND 0)
  endif()
  find_package(PkgConfig)
  find_package(Fontconfig)
  if(PkgConfig_FOUND)
    pkg_check_modules(GTKGLEXT gtkglext-1.0)
    if(AUTO_X)
      pkg_check_modules(XRENDER xrender)
    elseif(WITH_X)
      pkg_check_modules(XRENDER REQUIRED xrender)
    else()
      message(STATUS "skipping xrender discovery because -DWITH_X=OFF")
      set(XRENDER_FOUND 0)
    endif()
  endif()
  if(Freetype_FOUND AND GLUT_FOUND AND GTK2_FOUND AND Fontconfig_FOUND AND
     GTKGLEXT_FOUND AND GTS_FOUND AND XRENDER_FOUND)
    if(WITH_SMYRNA STREQUAL "AUTO")
      message(STATUS "setting -DWITH_SMYRNA=ON")
      set(WITH_SMYRNA ON)
    endif()
  else()
    if(WITH_SMYRNA STREQUAL "AUTO")
      message(STATUS "setting -DWITH_SMYRNA=OFF")
      set(WITH_SMYRNA OFF)
    else()
      message(FATAL_ERROR "-DWITH_SMYRNA=ON and dependencies not found")
    endif()
  endif()
endif()

find_package(GD)
if(WITH_GHOSTSCRIPT)
  find_package(GS)
  if(NOT AUTO_GHOSTSCRIPT)
    set_package_properties(GS PROPERTIES TYPE REQUIRED)
  endif()
else()
  message(STATUS
          "skipping Ghostscript discovery because -DWITH_GHOSTSCRIPT=OFF")
  set(GS_FOUND 0)
endif()

if(NOT ENABLE_LTDL STREQUAL "OFF")
  find_package(LTDL)
  if(ENABLE_LTDL STREQUAL "AUTO")
    if(LTDL_FOUND)
      message(STATUS "setting -DENABLE_LTDL=ON")
      set(ENABLE_LTDL ON)
    else()
      message(STATUS "setting -DENABLE_LTDL=OFF")
      set(ENABLE_LTDL OFF)
    endif()
  elseif(NOT LTDL_FOUND)
    message(FATAL_ERROR "-DENABLE_LTDL=ON and ltdl not found")
  endif()
endif()
if(ENABLE_LTDL)
  add_definitions(-DENABLE_LTDL)
endif()

find_package(AA)
find_package(DevIL)
find_package(Freetype)
find_package(PANGOCAIRO)
find_package(PkgConfig)
if(PkgConfig_FOUND)
  if(WITH_GDK STREQUAL "OFF")
    message(STATUS "skipping GDK discovery because -DWITH_GDK=OFF")
    set(GDK_FOUND 0)
  else()
    pkg_check_modules(GDK gdk-3.0)
  endif()
  if(WITH_GDK STREQUAL "ON")
    if(NOT GDK_FOUND)
      message(FATAL_ERROR "-DWITH_GDK=ON and GDK not found")
    endif()
  endif()
  pkg_check_modules(GDK_PIXBUF gdk-pixbuf-2.0)
  pkg_check_modules(LASI lasi)
  if(AUTO_POPPLER)
    pkg_check_modules(POPPLER poppler-glib)
  elseif(WITH_POPPLER)
    pkg_check_modules(POPPLER REQUIRED poppler-glib)
  else()
    message(STATUS "skipping Poppler discovery because -DWITH_POPPLER=OFF")
    set(POPPLER_FOUND 0)
  endif()
  if(AUTO_RSVG)
    pkg_check_modules(RSVG librsvg-2.0)
  elseif(WITH_RSVG)
    pkg_check_modules(RSVG REQUIRED librsvg-2.0)
  else()
    message(STATUS "skipping librsvg discovery because -DWITH_RSVG=OFF")
    set(RSVG_FOUND 0)
  endif()
  if(AUTO_WEBP)
    pkg_check_modules(WEBP libwebp)

=== tests/CMakeLists.txt ===
if(CMAKE_VERSION VERSION_GREATER_EQUAL "3.30")
  # is Boost available and new enough to ship its own config?
  cmake_policy(SET CMP0167 NEW)
  find_package(Boost CONFIG)

  # if not, fallback to CMake’s Boost config
  if(NOT Boost_FOUND)
    cmake_policy(SET CMP0167 OLD)
    find_package(Boost REQUIRED)
  endif()
else()
  find_package(Boost REQUIRED)
endif()

find_package(Catch2 3 REQUIRED)
find_package(RAPIDXML REQUIRED)
find_package(SVGPP REQUIRED)

enable_testing()

add_library(test_common STATIC
            graphviz_edge.cpp
            graphviz_edge.h
            graphviz_graph.cpp
            graphviz_graph.h
            graphviz_node.h
            graphviz_node.cpp
            test_utilities.cpp
            svgpp_context.cpp
            svgpp_context.h
            svgpp_document_traverser.cpp
            svgpp_document_traverser.h
            svg_analyzer.cpp
            svg_analyzer.h
            svg_analyzer_interface.h
            svg_element.cpp
            svg_element.h
            test_edge_node_overlap_utilities.cpp
            test_edge_node_overlap_utilities.h
            ../cmd/dot/dot_builtins.cpp
)
set_target_properties(test_common PROPERTIES CXX_STANDARD 20)
set_target_properties(test_common PROPERTIES CXX_STANDARD_REQUIRED ON)
target_include_directories(test_common PRIVATE
  ../lib
  ../lib/cgraph++
)
target_include_directories(test_common SYSTEM PRIVATE
  ${Boost_INCLUDE_DIRS}
  ${RAPIDXML_INCLUDE_DIRS}
  ${SVGPP_INCLUDE_DIRS}
)
target_link_libraries(test_common PUBLIC
  gvplugin_core
  gvplugin_dot_layout
  gvplugin_gd
  gvplugin_kitty
  gvplugin_neato_layout
  gvplugin_pango
  gvplugin_vt
  gvplugin_webp
  cgraph
  cgraph++
  gvc
  gvc++
  Catch2::Catch2
)

# common steps for creating a test case
macro(CREATE_TEST testname)
  add_executable(test_${testname} test_${testname}.cpp)
  set_target_properties(test_${testname} PROPERTIES CXX_STANDARD 20)
  set_target_properties(test_${testname} PROPERTIES CXX_STANDARD_REQUIRED ON)
  add_test(NAME test_${testname}
           COMMAND ./test_${testname} --reporter JUnit::out=test_${testname}.xml
             --reporter console::out=-::colour-mode=ansi)
  target_include_directories(test_${testname} PRIVATE
    ../lib
    ../lib/cdt
    ../lib/cgraph
    ../lib/cgraph++
    ../lib/common
    ../lib/gvc
    ../lib/pathplan
  )
  target_link_libraries(test_${testname} PRIVATE
    test_common
  )
  target_link_libraries(test_${testname} PRIVATE Catch2::Catch2WithMain)
endmacro()

CREATE_TEST(AGraph_construction)
CREATE_TEST(clusters)
CREATE_TEST(edge_color)
CREATE_TEST(edge_fillcolor)
CREATE_TEST(edge_penwidth)
CREATE_TEST(engines)
CREATE_TEST(GVContext_construction)
CREATE_TEST(GVContext_render_svg)
CREATE_TEST(GVLayout_construction)
CREATE_TEST(GVLayout_render)
CREATE_TEST(edge_node_overlap_all_edge_arrows)
CREATE_TEST(edge_node_overlap_all_node_shapes)
CREATE_TEST(edge_node_overlap_all_primitive_edge_arrows)
CREATE_TEST(edge_node_overlap_box_edge_arrow)
CREATE_TEST(edge_node_overlap_box_edge_arrow_various_arrowsizes)
CREATE_TEST(edge_node_overlap_crow_and_vee_edge_arrows)
CREATE_TEST(edge_node_overlap_curve_and_icurve_edge_arrows)
CREATE_TEST(edge_node_overlap_cylinder_node_shape)
CREATE_TEST(edge_node_overlap_diamond_edge_arrow)
CREATE_TEST(edge_node_overlap_diamond_edge_arrow_various_arrowsizes)
CREATE_TEST(edge_node_overlap_dot_edge_arrow)
CREATE_TEST(edge_node_overlap_dot_edge_arrow_various_arrowsizes)
CREATE_TEST(edge_node_overlap_ellipse_node_shapes_except_point)
CREATE_TEST(edge_node_overlap_none_edge_arrow)
CREATE_TEST(edge_node_overlap_none_edge_arrow_various_arrowsizes)
CREATE_TEST(edge_node_overlap_normal_and_inv_edge_arrows)
CREATE_TEST(edge_node_overlap_normal_and_inv_edge_arrows_all_modifiers)
CREATE_TEST(edge_node_overlap_normal_and_inv_edge_arrows_various_arrowsizes)
CREATE_TEST(edge_node_overlap_plain_node_shape)
CREATE_TEST(edge_node_overlap_point_node_shape)
CREATE_TEST(edge_node_overlap_polygon_node_shapes)
CREATE_TEST(edge_node_overlap_record_node_shape)
CREATE_TEST(edge_node_overlap_simple)
CREATE_TEST(edge_node_overlap_tee_edge_arrow)
CREATE_TEST(edge_node_overlap_tee_edge_arrow_various_arrowsizes)
CREATE_TEST(max_edge_node_overlap_simple)
CREATE_TEST(max_edge_node_overlap_polygon_node_shapes)
CREATE_TEST(min_edge_node_overlap_polygon_node_shapes)
CREATE_TEST(min_edge_node_overlap_simple)
CREATE_TEST(max_edge_stem_arrow_overlap_simple)
CREATE_TEST(min_edge_stem_arrow_overlap_simple)
CREATE_TEST(neatopack)
CREATE_TEST(node_color)
CREATE_TEST(node_fillcolor)
CREATE_TEST(node_penwidth)
CREATE_TEST(rankdir)
CREATE_TEST(simple)
CREATE_TEST(subgraph_layout)
CREATE_TEST(subgraphs)
CREATE_TEST(svg_analyzer)
CREATE_TEST(svg_analyzer_color)
CREATE_TEST(svg_analyzer_fillcolor)
CREATE_TEST(svg_analyzer_penwidth)

=== cmd/gvmap/CMakeLists.txt ===
if(with_sfdp)

  add_executable(cluster
    cluster.c
    country_graph_coloring.c
    make_map.c
    power.c
  )

  target_include_directories(cluster PRIVATE
    ../../lib
    ../../lib/cdt
    ../../lib/cgraph
    ../../lib/common
  )

  if(GETOPT_FOUND)
    target_include_directories(cluster SYSTEM PRIVATE
      ${GETOPT_INCLUDE_DIRS}
    )
  endif()

  target_link_libraries(cluster PRIVATE
    cgraph
    edgepaintlib
    gvc
    neatogen
    rbtree
    sfdpgen
    sparse
  )

  if(NOT HAVE_GETOPT_H)
    target_link_libraries(cluster PRIVATE ${GETOPT_LINK_LIBRARIES})
  endif()

  find_program(GZIP gzip)
  if(GZIP)
    add_custom_target(man-cluster ALL DEPENDS cluster.1.gz
                      COMMENT "cluster man page")
    add_custom_command(
      OUTPUT cluster.1.gz
      COMMAND ${GZIP} -9 --no-name --to-stdout cluster.1
        >"${CMAKE_CURRENT_BINARY_DIR}/cluster.1.gz"
      MAIN_DEPENDENCY cluster.1
      WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
      COMMENT "compress cluster man page")
    install(
      FILES ${CMAKE_CURRENT_BINARY_DIR}/cluster.1.gz
      DESTINATION ${MAN_INSTALL_DIR}/man1)
  else()
    install(
      FILES cluster.1
      DESTINATION ${MAN_INSTALL_DIR}/man1
    )
  endif()

  install(
    TARGETS cluster
    RUNTIME DESTINATION ${BINARY_INSTALL_DIR}
    LIBRARY DESTINATION ${LIBRARY_INSTALL_DIR}
    ARCHIVE DESTINATION ${LIBRARY_INSTALL_DIR}
  )

  add_executable(gvmap
    country_graph_coloring.c
    country_graph_coloring.h
    gvmap.c
    make_map.c
    make_map.h
    power.c
    power.h
  )

  target_include_directories(gvmap PRIVATE
    ../../lib
    ../../lib/common
    ../../lib/cgraph
    ../../lib/cdt
  )

  if(GETOPT_FOUND)
    target_include_directories(gvmap SYSTEM PRIVATE
      ${GETOPT_INCLUDE_DIRS}
    )
  endif()

  target_link_libraries(gvmap PRIVATE
    cgraph
    edgepaintlib
    gvc
    neatogen
    rbtree
    sfdpgen
    sparse
  )

  if(NOT HAVE_GETOPT_H)
    target_link_libraries(gvmap PRIVATE ${GETOPT_LINK_LIBRARIES})
  endif()

  if(GZIP)
    add_custom_target(man-gvmap ALL DEPENDS gvmap.1.gz
                      COMMENT "gvmap man page")
    add_custom_command(
      OUTPUT gvmap.1.gz
      COMMAND ${GZIP} -9 --no-name --to-stdout gvmap.1
        >"${CMAKE_CURRENT_BINARY_DIR}/gvmap.1.gz"
      MAIN_DEPENDENCY gvmap.1
      WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
      COMMENT "compress gvmap man page")
    install(
      FILES ${CMAKE_CURRENT_BINARY_DIR}/gvmap.1.gz
      DESTINATION ${MAN_INSTALL_DIR}/man1)
  else()
    install(
      FILES gvmap.1
      DESTINATION ${MAN_INSTALL_DIR}/man1
    )
  endif()

  install(
    TARGETS gvmap
    RUNTIME DESTINATION ${BINARY_INSTALL_DIR}
    LIBRARY DESTINATION ${LIBRARY_INSTALL_DIR}
    ARCHIVE DESTINATION ${LIBRARY_INSTALL_DIR}
  )

  install(
    FILES gvmap.sh
    DESTINATION ${BINARY_INSTALL_DIR}
    PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE
      WORLD_READ WORLD_EXECUTE
  )

  if(GZIP)
    add_custom_target(man-gvmap-sh ALL
      DEPENDS gvmap.sh.1.gz
      COMMENT "gvmap.sh man page"
    )
    add_custom_command(
      OUTPUT gvmap.sh.1.gz
      COMMAND ${GZIP} -9 --no-name --to-stdout gvmap.sh.1
        >"${CMAKE_CURRENT_BINARY_DIR}/gvmap.sh.1.gz"
      MAIN_DEPENDENCY gvmap.sh.1
      WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
      COMMENT "compress gvmap.sh man page"
    )
    install(
      FILES ${CMAKE_CURRENT_BINARY_DIR}/gvmap.sh.1.gz
      DESTINATION ${MAN_INSTALL_DIR}/man1
    )
  else()
    install(
      FILES gvmap.sh.1
      DESTINATION ${MAN_INSTALL_DIR}/man1
    )
  endif()
endif()

=== cmd/tools/CMakeLists.txt ===
# This function sets some default values that every tools shares:
# - linking to getopt if REQUIRED
# - installation of executable
# - installation of manpage
function(tool_defaults name)
  if(NOT HAVE_GETOPT_H)
    target_link_libraries(${name} PRIVATE ${GETOPT_LINK_LIBRARIES})
  endif()

  install(
    TARGETS ${name}
    RUNTIME DESTINATION ${BINARY_INSTALL_DIR}
    LIBRARY DESTINATION ${LIBRARY_INSTALL_DIR}
    ARCHIVE DESTINATION ${LIBRARY_INSTALL_DIR}
  )

  if(GZIP)
    add_custom_target(man-${name} ALL DEPENDS ${name}.1.gz
                      COMMENT "${name} man page")
    add_custom_command(
      OUTPUT ${name}.1.gz
      COMMAND ${GZIP} -9 --no-name --to-stdout ${name}.1
        >"${CMAKE_CURRENT_BINARY_DIR}/${name}.1.gz"
      MAIN_DEPENDENCY ${name}.1
      WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
      COMMENT "compress ${name} man page")
    install(
      FILES ${CMAKE_CURRENT_BINARY_DIR}/${name}.1.gz
      DESTINATION ${MAN_INSTALL_DIR}/man1)
  else()
    install(
      FILES ${name}.1
      DESTINATION ${MAN_INSTALL_DIR}/man1
    )
  endif()
endfunction(tool_defaults)

# ================================ simple tools ================================
# These tools have a single source file and share linked libraries, etc.

# This function adds a simple tool using only its name
function(add_simple_tool name)
  add_executable(${name} ${name}.c)

  target_include_directories(${name} PRIVATE
    ../../lib
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_CURRENT_BINARY_DIR}
    ../../lib/cdt
    ../../lib/cgraph
    ../../lib/common
    ../../lib/gvc
    ../../lib/pack
    ../../lib/pathplan
  )

  if(GETOPT_FOUND)
    target_include_directories(${name} SYSTEM PRIVATE
      ${GETOPT_INCLUDE_DIRS}
    )
  endif()

  target_link_libraries(${name} PRIVATE
    cgraph
  )

  tool_defaults(${name})
endfunction(add_simple_tool)

add_simple_tool(acyclic)
add_simple_tool(bcomps)
target_link_libraries(bcomps PRIVATE util)
add_simple_tool(ccomps)
target_link_libraries(ccomps PRIVATE gvc util)
add_simple_tool(nop)
add_simple_tool(tred)
target_link_libraries(tred PRIVATE gvc) # e.g. for start_timer
add_simple_tool(unflatten)

# ================================ complex tools ===============================
# These tools have multiple source files, different dependencies or other
# differences from the simple tools above

# ================================== gc ========================================
add_executable(gc_bin gc.c)
set_target_properties(gc_bin PROPERTIES OUTPUT_NAME "gc")

target_include_directories(gc_bin PRIVATE
  ../../lib
  ${CMAKE_CURRENT_SOURCE_DIR}
  ${CMAKE_CURRENT_BINARY_DIR}
  ../../lib/cdt
  ../../lib/cgraph
  ../../lib/common
  ../../lib/gvc
  ../../lib/pack
  ../../lib/pathplan
)

if(GETOPT_FOUND)
  target_include_directories(gc_bin SYSTEM PRIVATE ${GETOPT_INCLUDE_DIRS})
endif()
if(NOT HAVE_GETOPT_H)
  target_link_libraries(gc_bin PRIVATE ${GETOPT_LINK_LIBRARIES})
endif()

target_link_libraries(gc_bin PRIVATE
  cgraph
  gvc
  util
)

install(
  TARGETS gc_bin
  RUNTIME DESTINATION ${BINARY_INSTALL_DIR}
  LIBRARY DESTINATION ${LIBRARY_INSTALL_DIR}
  ARCHIVE DESTINATION ${LIBRARY_INSTALL_DIR}
)

if(GZIP)
  add_custom_target(man-gc ALL DEPENDS gc.1.gz
                    COMMENT "gc man page")
  add_custom_command(
    OUTPUT gc.1.gz
    COMMAND ${GZIP} -9 --no-name --to-stdout gc.1
      >"${CMAKE_CURRENT_BINARY_DIR}/gc.1.gz"
    MAIN_DEPENDENCY gc.1
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
    COMMENT "compress gc man page")
  install(
    FILES ${CMAKE_CURRENT_BINARY_DIR}/gc.1.gz
    DESTINATION ${MAN_INSTALL_DIR}/man1)
else()
  install(
    FILES gc.1
    DESTINATION ${MAN_INSTALL_DIR}/man1
  )
endif()

# ================================== dijkstra ==================================
add_executable(dijkstra
  # Source files
  dijkstra.c
)

target_include_directories(dijkstra PRIVATE
  ../../lib
  ${CMAKE_CURRENT_SOURCE_DIR}
  ${CMAKE_CURRENT_BINARY_DIR}
  ../../lib/cdt
  ../../lib/cgraph
  ../../lib/common
  ../../lib/gvc
  ../../lib/pack
  ../../lib/pathplan
)

if(GETOPT_FOUND)
  target_include_directories(dijkstra SYSTEM PRIVATE
    ${GETOPT_INCLUDE_DIRS}
  )
endif()

target_link_libraries(dijkstra PRIVATE
  cgraph
)

tool_defaults(dijkstra)

# =================================== gml2gv ===================================
BISON_TARGET(Gmlparse ${CMAKE_CURRENT_SOURCE_DIR}/gmlparse.y
                      ${CMAKE_CURRENT_BINARY_DIR}/gmlparse.c)
FLEX_TARGET(Gmlscan
  ${CMAKE_CURRENT_SOURCE_DIR}/gmlscan.l
  ${CMAKE_CURRENT_BINARY_DIR}/gmlscan.c
  COMPILE_FLAGS --case-insensitive
)
ADD_FLEX_BISON_DEPENDENCY(Gmlscan Gmlparse)

add_executable(gml2gv
  # Source files
  gml2gv.c

  # Generated files
  ${BISON_Gmlparse_OUTPUTS}
  ${FLEX_Gmlscan_OUTPUTS}
)

if(WIN32 AND NOT MINGW)
  target_compile_definitions(gml2gv PRIVATE -DYY_NO_UNISTD_H)
endif()

target_include_directories(gml2gv PRIVATE
  ../../lib
  ${CMAKE_CURRENT_SOURCE_DIR}
  ${CMAKE_CURRENT_BINARY_DIR}
  ../../lib/cdt
  ../../lib/cgraph
  ../../lib/common
  ../../lib/gvc
  ../../lib/pack
  ../../lib/pathplan
)

if(GETOPT_FOUND)
  target_include_directories(gml2gv SYSTEM PRIVATE
    ${GETOPT_INCLUDE_DIRS}
  )
endif()

target_link_libraries(gml2gv PRIVATE
  cgraph
  util
)

tool_defaults(gml2gv)

add_executable(gv2gml gv2gml.c)
target_include_directories(gv2gml PRIVATE
  ../../lib
  ../../lib/cdt
  ../../lib/cgraph
  ../../lib/common
  ../../lib/gvc
  ../../lib/pathplan
)
if(GETOPT_FOUND)
  target_include_directories(gv2gml SYSTEM PRIVATE
    ${GETOPT_INCLUDE_DIRS}
  )
endif()
target_link_libraries(gv2gml PRIVATE cgraph gvc util)
if(NOT HAVE_GETOPT_H)
  target_link_libraries(gv2gml PRIVATE ${GETOPT_LINK_LIBRARIES})
endif()
install(TARGETS gv2gml RUNTIME DESTINATION ${BINARY_INSTALL_DIR})

if(WIN32 OR CYGWIN)
  if(GZIP)
    add_custom_target(man-gv2gml ALL
      DEPENDS gv2gml.1.gz
      COMMENT "gv2gml man page"
    )
    add_custom_command(
      OUTPUT gv2gml.1.gz
      COMMAND ${CMAKE_COMMAND} -E copy gml2gv.1.gz gv2gml.1.gz
      MAIN_DEPENDENCY gml2gv.1.gz
      COMMENT "Copying gml2gv.1.gz to gv2gml.1.gz"
    )
    install(
      FILES ${CMAKE_CURRENT_BINARY_DIR}/gv2gml.1.gz
      DESTINATION ${MAN_INSTALL_DIR}/man1
    )
  else()
    install(
      FILES gml2gv.1
      DESTINATION ${MAN_INSTALL_DIR}/man1
      RENAME gv2gml.1
    )
  endif()
else()
  if(GZIP)
    add_custom_target(man-gv2gml ALL
      DEPENDS gv2gml.1.gz
      COMMENT "gv2gml man page"
    )
    add_custom_command(
      OUTPUT gv2gml.1.gz
      COMMAND ${CMAKE_COMMAND} -E create_symlink gml2gv.1.gz gv2gml.1.gz
      COMMENT "Linking gml2gv.1.gz as gv2gml.1.gz"
    )
    install(
      FILES ${CMAKE_CURRENT_BINARY_DIR}/gv2gml.1.gz
      DESTINATION ${MAN_INSTALL_DIR}/man1
    )
  else()
    add_custom_target(man-gv2gml ALL
      DEPENDS gv2gml.1
      COMMENT "gv2gml man page"
    )
    add_custom_command(
      OUTPUT gv2gml.1
      COMMAND ${CMAKE_COMMAND} -E create_symlink gml2gv.1 gv2gml.1
      COMMENT "Linking gml2gv.1 as gv2gml.1"
    )
    install(
      FILES ${CMAKE_CURRENT_BINARY_DIR}/gv2gml.1
      DESTINATION ${MAN_INSTALL_DIR}/man1
    )
  endif()
endif()

# ================================= graphml2gv =================================
if(EXPAT_FOUND)

  add_executable(graphml2gv
    # Source files
    graphml2gv.c
  )

  target_include_directories(graphml2gv PRIVATE
    ../../lib
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_CURRENT_BINARY_DIR}
    ../../lib/cdt
    ../../lib/cgraph
    ../../lib/common
    ../../lib/gvc
    ../../lib/pack
    ../../lib/pathplan
  )

  target_include_directories(graphml2gv SYSTEM PRIVATE
    ${EXPAT_INCLUDE_DIRS}
  )

  if(GETOPT_FOUND)
    target_include_directories(graphml2gv SYSTEM PRIVATE
      ${GETOPT_INCLUDE_DIRS}
    )
  endif()

  target_link_libraries(graphml2gv PRIVATE
    cgraph
    util
    ${EXPAT_LIBRARIES}
  )

  tool_defaults(graphml2gv)

endif()

# ================================== gvcolor ===================================
add_executable(gvcolor
  # Header files
  colortbl.h

  # Source files
  colxlate.c
  gvcolor.c
)

target_include_directories(gvcolor PRIVATE
  ../../lib
  ${CMAKE_CURRENT_SOURCE_DIR}
  ${CMAKE_CURRENT_BINARY_DIR}
  ../../lib/cdt
  ../../lib/cgraph
  ../../lib/common
  ../../lib/gvc
  ../../lib/pack
  ../../lib/pathplan
)

if(GETOPT_FOUND)
  target_include_directories(gvcolor SYSTEM PRIVATE
    ${GETOPT_INCLUDE_DIRS}
  )
endif()

target_link_libraries(gvcolor PRIVATE
  cgraph
)

tool_defaults(gvcolor)

# ==================================== gvgen ===================================
add_executable(gvgen
  # Source files
  graph_generator.c
  gvgen.c
)

target_include_directories(gvgen PRIVATE
  ../../lib
  ${CMAKE_CURRENT_SOURCE_DIR}
  ${CMAKE_CURRENT_BINARY_DIR}
  ../../lib/cdt
  ../../lib/cgraph
  ../../lib/common
  ../../lib/gvc
  ../../lib/pack
  ../../lib/pathplan
)

if (GETOPT_FOUND)
  target_include_directories(gvgen SYSTEM PRIVATE
    ${GETOPT_INCLUDE_DIRS}
  )
endif()

target_link_libraries(gvgen PRIVATE cgraph util)

tool_defaults(gvgen)

# =================================== gvpack ===================================
# TODO add gvpack_static

add_executable(gvpack
  # Source files
  gvpack.cpp
)

target_compile_definitions(gvpack PRIVATE DEMAND_LOADING=0)

target_include_directories(gvpack PRIVATE
  ../../lib
  ${CMAKE_CURRENT_SOURCE_DIR}
  ${CMAKE_CURRENT_BINARY_DIR}
  ../../lib/cdt
  ../../lib/cgraph
  ../../lib/common
  ../../lib/gvc
  ../../lib/pack
  ../../lib/pathplan
)

if(GETOPT_FOUND)
  target_include_directories(gvpack SYSTEM PRIVATE
    ${GETOPT_INCLUDE_DIRS}
  )
endif()

target_link_libraries(gvpack PRIVATE
  cgraph
  gvc
)
if(BUILD_SHARED_LIBS)
  target_link_libraries(gvpack PRIVATE gvplugin_neato_layout)
else()
  target_link_libraries(gvpack PRIVATE
    $<TARGET_OBJECTS:gvplugin_neato_layout>
    $<TARGET_PROPERTY:gvplugin_neato_layout,LINK_LIBRARIES>
  )
endif()

tool_defaults(gvpack)

# =================================== gxl2gv ===================================
if(EXPAT_FOUND)

  add_executable(gxl2gv
    # Source files
    cvtgxl.c
    gv2gxl.c
    gxl2gv.c
  )

  target_include_directories(gxl2gv PRIVATE
    ../../lib
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_CURRENT_BINARY_DIR}
    ../../lib/cdt
    ../../lib/cgraph
    ../../lib/common
    ../../lib/gvc
    ../../lib/pack
    ../../lib/pathplan
  )

  target_include_directories(gxl2gv SYSTEM PRIVATE
    ${EXPAT_INCLUDE_DIRS}
  )
  if(GETOPT_FOUND)
    target_include_directories(gxl2gv SYSTEM PRIVATE
      ${GETOPT_INCLUDE_DIRS}
    )
  endif()

  target_link_libraries(gxl2gv PRIVATE
    cgraph
    util
    ${EXPAT_LIBRARIES}
  )

  tool_defaults(gxl2gv)

  list(APPEND gxl2gv_aliases dot2gxl gv2gxl gxl2dot)
  foreach(cmd_alias IN LISTS gxl2gv_aliases)
    set(GXL2GV_COPY
        "${CMAKE_CURRENT_BINARY_DIR}/${cmd_alias}${CMAKE_EXECUTABLE_SUFFIX}")
    if(WIN32 OR CYGWIN)
      # copy instead of symlink to avoid
      # https://gitlab.com/graphviz/graphviz/-/issues/2123
      add_custom_command(
        TARGET gxl2gv
        POST_BUILD
        COMMAND ${CMAKE_COMMAND} -E copy $<TARGET_FILE:gxl2gv> ${GXL2GV_COPY}
        COMMENT "Copying gxl2gv to ${GXL2GV_COPY}"
      )
      install(
        PROGRAMS ${GXL2GV_COPY}
        DESTINATION ${BINARY_INSTALL_DIR}
      )
      if(GZIP)
        add_custom_target(man-${cmd_alias} ALL
          DEPENDS ${cmd_alias}.1.gz
          COMMENT "${cmd_alias} man page"
        )
        add_custom_command(
          OUTPUT ${cmd_alias}.1.gz
          COMMAND ${CMAKE_COMMAND} -E copy gxl2gv.1.gz ${cmd_alias}.1.gz
          MAIN_DEPENDENCY gxl2gv.1.gz
          COMMENT "Copying gxl2gv.1.gz to ${cmd_alias}.1.gz"
        )
        install(
          FILES ${CMAKE_CURRENT_BINARY_DIR}/${cmd_alias}.1.gz
          DESTINATION ${MAN_INSTALL_DIR}/man1
        )
      else()
        install(
          FILES gxl2gv.1
          DESTINATION ${MAN_INSTALL_DIR}/man1
          RENAME ${cmd_alias}.1
        )
      endif()

=== contrib/diffimg/CMakeLists.txt ===
find_package(GD)

if(GD_FOUND)

  add_executable(diffimg diffimg.c)
  target_include_directories(diffimg PRIVATE ../../lib)
  target_include_directories(diffimg SYSTEM PRIVATE ${GD_INCLUDE_DIRS})
  target_link_libraries(diffimg PRIVATE ${GD_LIBRARIES})

  install(
    TARGETS diffimg
    RUNTIME DESTINATION ${BINARY_INSTALL_DIR}
    LIBRARY DESTINATION ${LIBRARY_INSTALL_DIR}
    ARCHIVE DESTINATION ${LIBRARY_INSTALL_DIR}
  )

  if(GZIP)
    add_custom_target(man-diffimg ALL DEPENDS diffimg.1.gz
                      COMMENT "diffimg man page")
    add_custom_command(
      OUTPUT diffimg.1.gz
      COMMAND ${GZIP} -9 --no-name --to-stdout diffimg.1
        >"${CMAKE_CURRENT_BINARY_DIR}/diffimg.1.gz"
      MAIN_DEPENDENCY diffimg.1
      WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
      COMMENT "compress diffimg man page")
    install(
      FILES ${CMAKE_CURRENT_BINARY_DIR}/diffimg.1.gz
      DESTINATION ${MAN_INSTALL_DIR}/man1)
  else()
    install(
      FILES diffimg.1
      DESTINATION ${MAN_INSTALL_DIR}/man1
    )
  endif()

endif()

=== doc/docbook/Makefile ===
SRCS = \
       src/book.xml \
       src/bookinfo.xml \
       src/graphviz_plugins.xml \
       src/graphviz_scripting.xml

.PHONY: all
all: html pdf

dvi fo javahelp man pdf ps txt: $(SRCS)
	xmlto $@ src/book.xml


xhtml xhtml-nochunks html html-nochunks htmlhelp: $(SRCS)
	xmlto $@ -o $@ src/book.xml
	cp -rp src/imgs $@/

.PHONY: clean
clean:
	rm -rf xhtml xhtml-nochunks html html-nochunks htmlhelp book.*

=== doc/infosrc/Makefile ===
#
# Generator for on-line documentation.
#
# Required tools: cc, dot, awk, ksh, yacc, gs, python.
#  dot is used in mkarrows.sh, mkshapes.sh, mkstyles.sh, mktapers.sh, mksplines.sh
#  ps_to_png.sh and other make rules rely on netpbm tools.
#  
#  Install python modules with:
#  $ pip install --user -r requirements.txt
#
#  python is used to run:
#  - jconvert.py, which converts the json schema graphviz_json_schema.json to html.
#    This also relies on the python package json2html.
#
# The main products are web pages.
#
# The files listed after each give the main data files used to
# generate the page.
#
# If shapelist is extended, add entry to SGIF.

INSTALL = cp
INSTALL_DIR = ../info

XGIF = forward.gif back.gif both.gif nohead.gif

MGIF = constraint.gif record.gif fill.gif round.gif \
       mrecord.gif colorlist.gif record2.gif fixed.gif tee.gif

GRADPNG = g_lin0.png g_wlin0.png g_rad0.png g_lin45.png g_wlin45.png g_rad45.png g_lin90.png g_wlin90.png g_rad90.png \
          g_lin180.png g_wlin180.png g_rad180.png g_lin270.png g_wlin270.png g_rad270.png g_lin360.png g_wlin360.png g_rad360.png

STYLEPNG = n_solid.png n_dashed.png n_dotted.png n_bold.png n_filled.png n_rounded.png n_striped.png \
           n_wedged.png n_diagonals.png \
           e_solid.png e_dashed.png e_dotted.png e_bold.png \
           c_solid.png c_dashed.png c_dotted.png c_bold.png c_filled.png c_rounded.png c_striped.png

TAPERPNG = normal_forward.png normal_back.png normal_both.png normal_none.png \
           none_forward.png none_back.png none_both.png none_none.png

SPLINEPNG = spline_none.png spline_line.png spline_spline.png spline_ortho.png spline_curved.png spline_polyline.png

MPNG = plugins.png sdlshapes.png $(GRADPNG) $(STYLEPNG) $(TAPERPNG) $(SPLINEPNG)

SGIF = Mcircle.gif Mdiamond.gif Msquare.gif box.gif \
      circle.gif diamond.gif doublecircle.gif \
      doubleoctagon.gif egg.gif ellipse.gif hexagon.gif house.gif \
      invhouse.gif invtrapezium.gif invtriangle.gif none.gif underline.gif \
      octagon.gif oval.gif parallelogram.gif plaintext.gif note.gif \
      point.gif polygon.gif trapezium.gif triangle.gif cylinder.gif \
      tripleoctagon.gif pentagon.gif septagon.gif rect.gif plain.gif \
      rectangle.gif square.gif star.gif tab.gif folder.gif box3d.gif \
      component.gif promoter.gif cds.gif terminator.gif utr.gif \
      primersite.gif restrictionsite.gif fivepoverhang.gif \
      threepoverhang.gif noverhang.gif assembly.gif signature.gif \
      insulator.gif ribosite.gif rnastab.gif proteasesite.gif \
      proteinstab.gif rpromoter.gif rarrow.gif larrow.gif lpromoter.gif

AGIF = a_normal.gif a_inv.gif a_dot.gif a_invdot.gif a_odot.gif \
       a_invodot.gif a_curve.gif a_icurve.gif a_none.gif \
       a_tee.gif a_empty.gif a_invempty.gif a_open.gif \
       a_diamond.gif a_odiamond.gif a_box.gif a_obox.gif a_crow.gif \
       a_halfopen.gif a_ediamond.gif a_lteeoldiamond.gif

A2GIF= aa_box.gif aa_lbox.gif aa_rbox.gif aa_obox.gif aa_olbox.gif aa_orbox.gif\
       aa_crow.gif aa_lcrow.gif aa_rcrow.gif \
       aa_diamond.gif aa_ldiamond.gif aa_rdiamond.gif aa_odiamond.gif aa_oldiamond.gif aa_ordiamond.gif\
       aa_dot.gif aa_odot.gif \
       aa_inv.gif aa_linv.gif aa_rinv.gif aa_oinv.gif aa_olinv.gif aa_orinv.gif\
       aa_none.gif \
       aa_normal.gif aa_lnormal.gif aa_rnormal.gif aa_onormal.gif aa_olnormal.gif aa_ornormal.gif\
       aa_tee.gif aa_ltee.gif aa_rtee.gif \
       aa_vee.gif aa_lvee.gif aa_rvee.gif \
       aa_curve.gif aa_lcurve.gif aa_rcurve.gif \
       aa_icurve.gif aa_licurve.gif aa_ricurve.gif

       

GIF = $(SGIF) $(AGIF) $(MGIF) $(A2GIF) $(XGIF)
DOTS = tee.gv
HTML = \
	grammar.html \
	html_grammar.html \
	schema.html \
	arrow_grammar.html \
	arrow_table.html \
	brewer_colors.html \
	svg_colors.html \
	x11_colors.html
MISC = graphviz_json_schema.json
INSTALL_FILES = $(HTML) $(DOTS) $(SGIF) $(AGIF) $(A2GIF) $(MGIF) $(XGIF) $(MPNG) $(MISC)

.SUFFIXES: .gv .gif .dot .png

.dot.gif :
	dot -Tgif -o $@ $<

.gv.gif :
	dot -Tgif -o $@ $<

.gv.png :
	dot -Tpng -o $@ $<

.PHONY: all
all : $(HTML) $(GIF) $(MPNG)

.PHONY: install
install : all
	$(INSTALL) $(INSTALL_FILES) $(INSTALL_DIR)

record2.gif : record.dot
	dot -Tgif -Grankdir=LR -o $@ $<

sdlshapes.ps : sdlshapes.dot
	dot -Tps -lsdl.ps sdlshapes.dot > sdlshapes.ps

sdlshapes.png : sdlshapes.ps
	./ps_to_png.sh sdlshapes.ps sdlshapes.png

x11_colors.html : mkcolors.awk ../../lib/common/color_names
	awk -f mkcolors.awk ../../lib/common/color_names > x11_colors.html

svg_colors.html : mkcolors.awk svg.awk ../../lib/common/svgcolor_names
	awk -f svg.awk ../../lib/common/svgcolor_names | awk -f mkcolors.awk > svg_colors.html

brewer_colors.html : mkcolors.awk brewer.awk ../../lib/common/brewer_colors
	mkdir -p colortmp
	awk -f brewer.awk ../../lib/common/brewer_colors
	(for f in $$(ls colortmp); do awk -f mkcolors.awk --single-line colortmp/$$f; done) > brewer_colors.html
	rm -rf colortmp

schema.html : jconvert.py graphviz_json_schema.json
	./jconvert.py graphviz_json_schema.json schema.html

shapes : shapelist mkshapes.sh
	./mkshapes.sh
	touch shapes
 
html_grammar.html : mklang html_grammar
	./mklang html_grammar html_grammar.html

grammar.html : grammar mklang
	./mklang grammar grammar.html

arrow_grammar.html: mklang arrow_grammar
	./mklang arrow_grammar arrow_grammar.html

arrow_table.html: mkarrowtbl.sh $(A2GIF)
	./mkarrowtbl.sh $(A2GIF) > arrow_table.html

mklang : mklang.y
	yacc mklang.y
	cc -o mklang y.tab.c
	rm -rf y.tab.c

$(SGIF) : mkshapes.sh shapelist
	./mkshapes.sh

$(AGIF) :
	./mkarrows.sh $@

$(A2GIF) :
	./mkarrows.sh -s $@

$(GRADPNG) : mkgrads.sh
	./mkgrads.sh $@

$(STYLEPNG) : mkstyles.sh
	./mkstyles.sh $@

$(TAPERPNG) : mktapers.sh
	./mktapers.sh $@

$(SPLINEPNG) : mksplines.sh
	./mksplines.sh $@

.PHONY: clean
clean :
	rm -f mklang sdlshapes.ps sdlshapes.ppm

.PHONY: distclean
distclean : clean
	rm -f $(HTML)
	rm -f $(A2GIF) $(AGIF) $(SGIF) $(MGIF) $(MPNG) $(XGIF) shapes
	(for s in $$(cat shapelist); do rm -f $$s.gif; done)

EXTRA_DIST = $(XGIF) mklang.y mkarrows.sh mkshapes.sh mkstyles.sh mktapers.sh \
             mkarrowtbl.sh mkshhtml.py \
	           ps_to_png.sh arrow_grammar grammar html_grammar \
             shapelist \
             lang.1 lang.2 \
             brewer.awk mkcolors.awk svg.awk sz.awk \
             colorlist.dot html1.dot html4.dot round.dot constraint.dot \
             html2.dot mrecord.dot sdlshapes.dot fill.dot html3.dot record.dot \
             X11 eqn.gif plugins.gv

=== doc/libguide/Makefile ===
TEX=latex
PTEX=pdflatex
DVI=dvips

.PHONY: all
all : libguide.pdf

%.pdf : %.dot
	dot -Tps2 $< | epstopdf --filter --outfile=$@

# libguide.bbl

libguide.pdf : libguide.tex
	$(PTEX) libguide
	bibtex libguide
	$(PTEX) libguide
	@if grep "Label(s) may have changed" libguide.log; then $(PTEX) libguide; fi

libguide.ps : libguide.dvi 
	@if grep "Label(s) may have changed" libguide.log; then $(TEX) libguide.tex; fi
	$(DVI) -o libguide.ps libguide
	
TEXS = libguide.tex intro.tex basic.tex layouts.tex drivers.tex codegen.tex \
       plugins.tex unconnect.tex build.tex samples.tex types.tex

libguide.dvi : libguide.bbl $(TEXS)
	$(TEX) libguide.tex
	@if grep "Label(s) may have changed" libguide.log; then $(TEX) libguide.tex; fi

libguide.bbl : libguide.tex graphdraw.bib libguide.aux
	bibtex libguide

libguide.aux : libguide.tex
	$(TEX) libguide

.PHONY: clean
clean: 
	rm -rf *.bbl *.aux *.dvi *.ps *.pdf *.log *.toc *.blg

=== doc/neato/Makefile ===
GRAPHFILES =  \
	ER.pdf \
	fancy.pdf \
	G4_lenwt.pdf \
	G4_orig.pdf \
	G4_pinned.pdf \
	inet.pdf \
	jho.pdf \
	process.pdf \
	typeshar.pdf

# note Tps not Tps2
# for unknown reasons, neato -Tps2  | epsftopdf | pdflatex is bad
%.pdf : %.dot
	neato -Gstart=867000 -Tps $< | epstopdf --filter --outfile=$@

neato.pdf : neato.tex neato.bbl $(GRAPHFILES)
	pdflatex neato.tex
	@if grep "Label(s) may have changed" neato.log; then pdflatex neato.tex; fi

neato.bbl : neato.tex ../dotguide/graphdraw.bib neato.aux
	bibtex neato

neato.aux : neato.tex $(GRAPHFILES)
	pdflatex neato

.PHONY: clean
clean: 
	rm -rf *.ps *.pdf *.log

=== lib/cdt/CMakeLists.txt ===
add_definitions(-DEXPORT_CDT)

add_library(cdt
  # Header files
  cdt.h
  dthdr.h

  # Source files
  dtclose.c
  dtdisc.c
  dtextract.c
  dtflatten.c
  dthash.c
  dtmethod.c
  dtopen.c
  dtrenew.c
  dtrestore.c
  dtsize.c
  dtstat.c
  dtstrhash.c
  dttree.c
  dtview.c
  dtwalk.c
)

target_include_directories(cdt PRIVATE
  ..
  ${CMAKE_CURRENT_SOURCE_DIR})

# Installation location of library files
install(
  TARGETS cdt
  EXPORT cdtConfig
  RUNTIME DESTINATION ${BINARY_INSTALL_DIR}
  LIBRARY DESTINATION ${LIBRARY_INSTALL_DIR}
  ARCHIVE DESTINATION ${LIBRARY_INSTALL_DIR}
)

# Specify headers to be installed
install(
  FILES cdt.h
  DESTINATION ${HEADER_INSTALL_DIR}
)

# Specify man pages to be installed
if(GZIP)
  add_custom_target(man-cdt ALL DEPENDS cdt.3.gz
                    COMMENT "cdt man page")
  add_custom_command(
    OUTPUT cdt.3.gz
    COMMAND ${GZIP} -9 --no-name --to-stdout cdt.3
      >"${CMAKE_CURRENT_BINARY_DIR}/cdt.3.gz"
    MAIN_DEPENDENCY cdt.3
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
    COMMENT "compress cdt man page")
  install(
    FILES ${CMAKE_CURRENT_BINARY_DIR}/cdt.3.gz
    DESTINATION ${MAN_INSTALL_DIR}/man3)
else()
  install(
    FILES cdt.3
    DESTINATION ${MAN_INSTALL_DIR}/man3
  )
endif()

# Specify library version and soversion
set_target_properties(cdt PROPERTIES
  VERSION 6.0.0
  SOVERSION 6
)

if(BUILD_SHARED_LIBS)
  install(
    EXPORT cdtConfig
    FILE cdtConfig.cmake
    NAMESPACE graphviz::
    DESTINATION ${LIBRARY_INSTALL_DIR}/cmake/graphviz
  )
endif()

=== lib/common/CMakeLists.txt ===
BISON_TARGET(HTMLparse ${CMAKE_CURRENT_SOURCE_DIR}/htmlparse.y
                       ${CMAKE_CURRENT_BINARY_DIR}/htmlparse.c)

add_definitions(-DGVC_EXPORTS)

# Generate colortbl.h from sources
add_custom_command(
  OUTPUT common/colortbl.h
  DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/svgcolor_names
          ${CMAKE_CURRENT_SOURCE_DIR}/brewer_colors
          ${CMAKE_CURRENT_SOURCE_DIR}/color_names
          ${CMAKE_CURRENT_SOURCE_DIR}/make_colortbl.py
  COMMAND ${CMAKE_COMMAND} -E make_directory
          "${CMAKE_CURRENT_BINARY_DIR}/common"
  COMMAND ${Python3_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/make_colortbl.py
          ${CMAKE_CURRENT_SOURCE_DIR}/brewer_colors
          ${CMAKE_CURRENT_SOURCE_DIR}/svgcolor_names
          ${CMAKE_CURRENT_SOURCE_DIR}/color_names
          ${CMAKE_CURRENT_BINARY_DIR}/common/colortbl.h
  COMMENT "generate color table"
)

# Generate entities.h from entities.html
add_custom_command(
  OUTPUT common/entities.h
  MAIN_DEPENDENCY ${CMAKE_CURRENT_SOURCE_DIR}/entities.html
  DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/entities.py
  COMMAND ${CMAKE_COMMAND} -E make_directory
          "${CMAKE_CURRENT_BINARY_DIR}/common"
  COMMAND ${Python3_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/entities.py
          ${CMAKE_CURRENT_BINARY_DIR}/common/entities.h
  COMMENT "generate entities.h"
)

add_library(common_obj OBJECT
  # Header files
  arith.h
  boxes.h
  color.h
  colorprocs.h
  ${CMAKE_CURRENT_BINARY_DIR}/common/colortbl.h
  const.h
  ${CMAKE_CURRENT_BINARY_DIR}/common/entities.h
  geom.h
  geomprocs.h
  globals.h
  htmllex.h
  htmltable.h
  macros.h
  pointset.h
  ps_font_equiv.h
  render.h
  textspan.h
  textspan_lut.h
  types.h
  usershape.h
  utils.h

  # Source files
  args.c
  arrows.c
  colxlate.c
  ellipse.c
  emit.c
  geom.c
  globals.c
  htmllex.c
  htmltable.c
  input.c
  labels.c
  ns.c
  output.c
  pointset.c
  postproc.c
  psusershape.c
  routespl.c
  shapes.c
  splines.c
  taper.c
  textspan.c
  textspan_lut.c
  timing.c
  utils.c

  # Generated files
  ${BISON_HTMLparse_OUTPUTS}
)

if(HAVE_C_WUNUSED_BUT_SET_VARIABLE)
  set_source_files_properties(${BISON_HTMLparse_OUTPUTS}
    PROPERTIES COMPILE_FLAGS -Wno-unused-but-set-variable)
endif()

target_include_directories(common_obj PRIVATE
  ..
  ${CMAKE_CURRENT_SOURCE_DIR}
  ${CMAKE_CURRENT_BINARY_DIR}
  ../cdt
  ../cgraph
  ../gvc
  ../pack
  ../pathplan
)

if(EXPAT_FOUND)
  target_include_directories(common_obj SYSTEM PRIVATE
    ${EXPAT_INCLUDE_DIRS}
  )
endif()

if(WIN32)
  target_include_directories(common_obj
                             PRIVATE ${WINDOWS_DEPENDENCY_DIR}/include)
endif()

if(WIN32 AND NOT MINGW)
  target_include_directories(common_obj PRIVATE ../../windows/include/unistd)
endif()

# From https://gitlab.com/graphviz/graphviz/-/issues/1613 @mdwies 20093010
if(APPLE)
  target_compile_options(common_obj PRIVATE "-fno-common")
endif()

add_library(common STATIC
  $<TARGET_OBJECTS:common_obj>
)

target_link_libraries(common PRIVATE
  cgraph
  pathplan
  label
  xdot
  util
)

if(EXPAT_FOUND)
  target_link_libraries(common PRIVATE
    ${EXPAT_LIBRARIES}
  )
endif()

# Specify headers to be installed
install(
  FILES
    arith.h
    color.h
    geom.h
    textspan.h
    types.h
    usershape.h
  DESTINATION ${HEADER_INSTALL_DIR}
)

=== lib/fdpgen/CMakeLists.txt ===
add_definitions(-DNEATOGEN_EXPORTS=1)

add_library(fdpgen STATIC
  # Header files
  clusteredges.h
  comp.h
  dbg.h
  fdp.h
  grid.h
  tlayout.h
  xlayout.h

  # Source files
  clusteredges.c
  comp.c
  dbg.c
  fdpinit.c
  grid.c
  layout.c
  tlayout.c
  xlayout.c
)

target_include_directories(fdpgen PRIVATE
  ..
  ../cdt
  ../cgraph
  ../common
  ../gvc
  ../pack
  ../pathplan
)

target_link_libraries(fdpgen PRIVATE
  cgraph
  gvc
  pathplan
  util
)

=== debian/changelog ===
graphviz (14.0.2-1) experimental; urgency=medium

  * New upstream release.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sat, 25 Oct 2025 09:20:31 +0200

=== debian/control ===
Source: graphviz
Section: graphics
Priority: optional
Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
Standards-Version: 4.7.2
Build-Depends: tk-dev,
 tcl-dev,
 debhelper-compat (= 13),
 dh-python,
 libfreetype-dev,
 zlib1g-dev,
 libjpeg-dev,
 libpng-dev,
 libxaw7-dev,
 bison,
 flex,
 libexpat1-dev,
 libfontconfig-dev,
 swig,
 libperl-dev,
 libgd-dev,
 guile-3.0-dev,
 groff-base,
 ghostscript,
 lua5.4,
 liblua5.4-dev,
 ruby [!ia64],
 ruby-dev [!ia64],
 libargon2-dev,
 libsodium-dev,
 libxml2-dev,
 libpython3-dev,
 python3-dev:any,
 libcairo2-dev,
 libpango1.0-dev,
 libpoppler-glib-dev,
 chrpath,
 libgs-dev,
 libgts-dev,
 libann-dev,
 librsvg2-dev [!alpha !hppa !hurd-amd64 !hurd-i386 !ia64 !m68k !sh4],
 libwebp-dev,
 libdevil-dev,
 libglut-dev,
 doxygen,
 qt6-base-dev
Build-Conflicts: tcl8.3, tcl8.4, tcl8.5
Homepage: https://www.graphviz.org/

Package: graphviz
Architecture: any
Multi-Arch: foreign
Depends: ${shlibs:Depends}, libgvc7, libgvplugin-gd8, ${misc:Depends}
Breaks: libgraphviz-dev (<< 8.1.0-1~)
Recommends: fonts-liberation
Suggests: gsfonts, graphviz-doc
Description: rich set of graph drawing tools
 Graph drawing addresses the problem of visualizing structural information
 by constructing geometric representations of abstract graphs and networks.
 Automatic generation of graph drawings has important applications in key
 technologies such as database design, software engineering, VLSI and
 network design and visual interfaces in other domains. Situations where
 these tools might be particularly useful include:
 .
   * you would like to restructure a program and first need to understand
     the relationships between its types, procedures, and source files
   * you need to find the bottlenecks in an Internet backbone - not only
     individual links, but their relationships
   * you're debugging a protocol or microarchitecture represented as a
     finite state machine and need to figure out how a certain
     error state arises
   * you would like to browse a database schema, knowledge base, or
     distributed program represented graphically
   * you would like to see an overview of a collection of linked documents
   * you would like to discover patterns and communities of interest in a
     database of telephone calls or e-mail messages
 .
 This package contains the command-line tools.

Package: graphviz-tools
Architecture: any
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}
Breaks: graphviz (<< 8.1.0-1~)
Replaces: graphviz (<< 8.1.0-1~)
Description: rich set of graph drawing extra tools
 Graphviz is a set of graph drawing tools. See the description of the graphviz
 package for a full description.
 .
 This package contains the extra command-line tools.

Package: libgraphviz-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libgvc-dev (= ${binary:Version}), libcgraph-dev (= ${binary:Version}), libcdt-dev (= ${binary:Version}), libpathplan-dev (= ${binary:Version}), ${misc:Depends}
Breaks: graphviz (<< 8.1.0-1~)
Replaces: libgraphviz3-dev, libgraphviz4-dev (<< 2.16-3)
Provides: graphviz-dev
Description: graphviz libs and headers against which to build applications
 Graphviz is a set of graph drawing tools. See the description of the graphviz
 package for a full description.
 .
 This package installs the libraries and headers necessary to link graphviz
 library routines into an application. It also installs additional man pages.
 .
 Note: A graphviz user doesn't need to install this package.

Package: graphviz-doc
Depends: ${misc:Depends}
Architecture: all
Multi-Arch: foreign
Section: doc
Suggests: graphviz
Description: additional documentation for graphviz
 Graphviz is a set of graph drawing tools. See the description of the graphviz
 package for a full description.
 .
 This package installs HTML and PDF documentation for Graphviz, as well as
 examples.

#Package: smyrna
#Architecture: any
#Multi-Arch: foreign
#Depends: ${shlibs:Depends}, ${misc:Depends}
#Recommends: fonts-liberation
#Suggests: graphviz, gsfonts, graphviz-doc
#Description: viewer for graphs in the DOT format
# It is especially designed to handle large graphs, and allows flat and
# topological fisheye views. It is assumed the input graph has position
# information associated with all nodes. Using the Graphviz convention,
# a node's position is given by its \fIpos\fP attribute consisting of 2 or 3
# floating point numbers separated by commas.
# Nodes are drawn as points and edges as line segments.
#
Package: libgv-guile
Architecture: any
Multi-Arch: same
Section: interpreters
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Guile bindings for graphviz
 Graphviz is a set of graph drawing tools. See the description of the graphviz
 package for a full description.
 .
 This package contains the guile (3.0) bindings.

Package: libgv-lua
Architecture: any
Multi-Arch: same
Section: interpreters
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Lua bindings for graphviz
 Graphviz is a set of graph drawing tools. See the description of the graphviz
 package for a full description.
 .
 This package contains the lua bindings.

Package: libgv-perl
Architecture: any
Multi-Arch: same
Section: perl
Depends: ${perl:Depends}, ${shlibs:Depends}, ${misc:Depends}
Description: Perl bindings for graphviz
 Graphviz is a set of graph drawing tools. See the description of the graphviz
 package for a full description.
 .
 This package contains the Perl bindings.

Package: python3-gv
Architecture: any
Section: python
Depends: ${python3:Depends}, ${shlibs:Depends}, ${misc:Depends}
Breaks: libgv-python (<< 2.40.1-0~)
Replaces: libgv-python (<< 2.40.1-0~)
Description: Python3 bindings for graphviz
 Graphviz is a set of graph drawing tools. See the description of the graphviz
 package for a full description.
 .
 This package contains the Python3 bindings.

Package: libgv-ruby
Architecture: any
Multi-Arch: same
Section: ruby
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Ruby bindings for graphviz
 Graphviz is a set of graph drawing tools. See the description of the graphviz
 package for a full description.
 .
 This package contains the Ruby bindings.

Package: libgv-tcl
Depends: tcl-gv, ${misc:Depends}
Architecture: all
Priority: optional
Section: oldlibs
Description: Tcl bindings for graphviz (transitional package)
 This is a transitional package. It can safely be removed.

Package: tcl-gv
Architecture: any
Multi-Arch: same
Section: interpreters
Depends: ${shlibs:Depends}, ${misc:Depends}
Breaks: libgv-tcl (<< 8.1.0-1~)
Replaces: libgv-tcl (<< 8.1.0-1~)
Description: Tcl bindings for graphviz
 Graphviz is a set of graph drawing tools. See the description of the graphviz
 package for a full description.
 .
 This package contains the Tcl (8.6) bindings.

Package: libcgraph-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libcgraph8 (= ${binary:Version}), libcdt-dev (= ${binary:Version}), ${misc:Depends}
Breaks: libgraphviz-dev (<< 8.1.0-1~)
Replaces: libgraphviz-dev (<< 8.1.0-1~)
Description: rich set of graph drawing tools - cgraph library (devel)
 Graphviz is a set of graph drawing tools. See the description of the graphviz
 package for a full description.
 .
 This package installs the libraries and headers necessary to link graphviz
 library routines into an application. It also installs additional man pages.
 .
 Note: A graphviz user doesn't need to install this package.

Package: libcgraph8
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: rich set of graph drawing tools - cgraph library
 Graphviz is a set of graph drawing tools. See the description of the graphviz
 package for a full description.
 .
 This package contains the cgraph library.

Package: libcdt-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libcdt6 (= ${binary:Version}), ${misc:Depends}
Breaks: libgraphviz-dev (<< 8.1.0-1~)
Replaces: libgraphviz-dev (<< 8.1.0-1~)
Description: rich set of graph drawing tools - cdt library (devel)
 Graphviz is a set of graph drawing tools. See the description of the graphviz
 package for a full description.
 .
 This package installs the libraries and headers necessary to link graphviz
 library routines into an application. It also installs additional man pages.
 .
 Note: A graphviz user doesn't need to install this package.

Package: libcdt6
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: rich set of graph drawing tools - cdt library
 Graphviz is a set of graph drawing tools. See the description of the graphviz
 package for a full description.
 .
 This package contains the cdt library.

Package: libpathplan-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libpathplan4 (= ${binary:Version}), ${misc:Depends}
Breaks: libgraphviz-dev (<< 8.1.0-1~)
Replaces: libgraphviz-dev (<< 8.1.0-1~)
Description: rich set of graph drawing tools - pathplan library (devel)
 Graphviz is a set of graph drawing tools. See the description of the graphviz
 package for a full description.
 .
 This package installs the libraries and headers necessary to link graphviz
 library routines into an application. It also installs additional man pages.
 .
 Note: A graphviz user doesn't need to install this package.

Package: libpathplan4
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: rich set of graph drawing tools - pathplan library
 Graphviz is a set of graph drawing tools. See the description of the graphviz
 package for a full description.
 .
 This package contains the pathplan library.

Package: libgvc-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libgvc7 (= ${binary:Version}), ${misc:Depends}
Breaks: libgraphviz-dev (<< 8.1.0-1~)
Replaces: libgraphviz-dev (<< 8.1.0-1~)
Description: rich set of graph drawing tools - gvc library (devel)
 Graphviz is a set of graph drawing tools. See the description of the graphviz
 package for a full description.
 .
 This package installs the libraries and headers necessary to link graphviz
 library routines into an application. It also installs additional man pages.
 .
 Note: A graphviz user doesn't need to install this package.

Package: libgvc7
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: rich set of graph drawing tools - gvc library
 Graphviz is a set of graph drawing tools. See the description of the graphviz
 package for a full description.
 .
 This package contains the gvc library.

#Package: libgvc6-plugins-gtk
#Architecture: any
#Multi-Arch: same
#Section: libs
#Depends: ${misc:Depends}, libgvplugin-gdk (= ${binary:Version}), libgvplugin-gtk (= ${binary:Version}), libgvplugin-rsvg (= ${binary:Version})
#Description: rich set of graph drawing tools - GTK plugins
# Graphviz is a set of graph drawing tools. See the description of the graphviz
# package for a full description.
# .
# This is an empty dependency package that pulls in the GDK and GTK plugins.
#
Package: libgvpr-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libgvpr2 (= ${binary:Version}), ${misc:Depends}
Breaks: libgraphviz-dev (<< 8.1.0-1~)
Replaces: libgraphviz-dev (<< 8.1.0-1~)
Description: rich set of graph drawing tools - gvpr library (devel)
 Graphviz is a set of graph drawing tools. See the description of the graphviz
 package for a full description.
 .
 This package installs the libraries and headers necessary to link graphviz
 library routines into an application. It also installs additional man pages.
 .
 Note: A graphviz user doesn't need to install this package.

Package: libgvpr2
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Replaces: libgvpr1
Description: rich set of graph drawing tools - gvpr library
 Graphviz is a set of graph drawing tools. See the description of the graphviz
 package for a full description.
 .

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

include /usr/share/dpkg/architecture.mk
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

AUTOGENERATED = graphviz.postinst graphviz.postrm graphviz.triggers libgvc7.postinst

ifeq ($(DEB_HOST_ARCH_OS),hurd)
CONFIGURE_LIBS    = LIBS="-Wl,--no-as-needed -Wl,-lpthread -Wl,--as-needed"
endif

ifneq (,$(filter $(DEB_HOST_ARCH), mipsel mips))
DEB_CFLAGS_MAINT_APPEND += "-fno-ipa-sra"
endif

N =

ifeq ($(DEB_HOST_ARCH),ia64)
RUBY = --disable-ruby
N += -Nlibgv-ruby
else
RUBY = --enable-ruby
endif

ifneq ($(DEB_BUILD_ARCH),$(DEB_HOST_ARCH))
PERLVER := $(shell perl -MConfig -e 'print $$Config{version}')
export PERL5LIB := /usr/lib/$(DEB_HOST_MULTIARCH)/perl/cross-config-$(PERLVER)
endif

PYTHON3_VERSIONS = $(shell py3versions -r)

override_dh_clean:
	dh_clean
	$(RM) $(patsubst %, debian/%, ${AUTOGENERATED})
	$(RM) $(CURDIR)/tclpkg/gv/*.pdf $(CURDIR)/cmd/dot/*.pdf
	$(RM) $(CURDIR)/tclpkg/gv/gv.3*
	$(RM) $(CURDIR)/configure $(CURDIR)/version.m4
	$(RM) -r $(CURDIR)/public/
	find $(CURDIR) -name Makefile.in -delete

override_dh_autoreconf:
	$(CURDIR)/autogen.sh NOCONFIG
	dh_autoreconf

override_dh_auto_configure:
	for f in ${AUTOGENERATED} ; do \
		sed -e 's%@TRIPLET@%${DEB_HOST_MULTIARCH}%g' \
			< debian/$$f.in \
			> debian/$$f ; \
	done
	dh_auto_configure -- \
	--disable-silent-rules \
	--prefix=/usr \
	--datadir=\$${prefix}/share \
	--infodir=\$${prefix}/share/info \
	--mandir=\$${prefix}/share/man \
	--enable-static \
	--without-included-ltdl \
	--with-pangocairo \
	--with-x \
	--with-gdk-pixbuf \
	--with-glut \
	--with-gnomeui \
	--without-gtk \
	--with-poppler \
	--with-gts \
	--with-ipsepcola \
	--with-qt \
	--with-rsvg \
	--with-ann \
	--with-webp \
	--with-devil \
	--without-smyrna \
	--disable-go \
	--enable-guile \
	--enable-lua \
	--disable-php \
	$(RUBY) \
	--enable-tcl \
	--disable-java \
	--disable-ocaml \
	--disable-r \
	--disable-sharp \
	--disable-python \
	--enable-python3 \
	$(CONFIGURE_LIBS) \
	$(shell $(dpkg_buildflags) --export=configure)

override_dh_auto_build-indep:
	dh_auto_build --indep
	# still need registered layout module
	PATH=./cmd/dot/:$(PATH) $(MAKE) doxygen

override_dh_auto_install:
	dh_auto_install
	find $(CURDIR)/debian/tmp/ -name \*.la -delete
	# move Tcl files to correct path
	install -d $(CURDIR)/debian/tmp/usr/lib/tcltk/$(DEB_HOST_MULTIARCH)/
	mv $(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/graphviz/tcl \
		$(CURDIR)/debian/tmp/usr/lib/tcltk/$(DEB_HOST_MULTIARCH)/gv
	# Duplicate library
#	rm $(CURDIR)/debian/tmp/usr/lib/tcl*/graphviz/libgv_tcl.so

override_dh_install-arch:
	dh_install --arch
	# NFU
	rm -rf $(CURDIR)/debian/tmp/usr/lib64/

#override_dh_auto_test:
#	dh_auto_test
#	pytest-3

override_dh_missing:
	dh_missing --list-missing

%:
	dh $@ --with python3 $(N)

.PHONY: override_dh_clean override_dh_autoreconf override_dh_auto_configure \
	override_dh_auto_build-indep \
	override_dh_auto_install override_dh_install-arch \
	override_dh_missing

=== debian/watch ===
version=4
https://graphviz.org/download/source/ .*/@PACKAGE@@ANY_VERSION@@ARCHIVE_EXT@
https://gitlab.com/graphviz/@PACKAGE@/-/tags .*releases/@ANY_VERSION@
https://qa.debian.org/cgi-bin/fakeupstream.cgi?upstream=gitlab_releases/graphviz/graphviz \
  .*/@PACKAGE@@ANY_VERSION@@ARCHIVE_EXT@
opts="searchmode=plain" https://gitlab.com/api/v4/projects/4207231/releases \
  [^"]*/@PACKAGE@@ANY_VERSION@@ARCHIVE_EXT@
